#include <iostream>
#include "MersenneTwister.h"
using namespace std;
#define MONTE_CARLO_STEPS 10000
struct dude
{
	bool hasRock;
	int x, y;
};
struct pedestal
{
	bool hasRock;
	int x,y;
};
int rock1 = 1, rock2 = 1, rock3 = 1; //Positions y = 2, x = 0,1,2
dude D;
MTRand Rand;
pedestal Pedestals[3];
void init()
{
	rock1 = 1;
	rock2 = 1;
	rock3 = 1;
	D.hasRock = false;
	D.x = 1;
	D.y = 1;
	for(int x = 0; x < 3; x++)
	{
		Pedestals[x].hasRock = false;
		Pedestals[x].x = x;
		Pedestals[x].y = 0;
	}
}
int serial()
{
	int timesteps = 0;
	while(!(Pedestals[0].hasRock && Pedestals[1].hasRock && Pedestals[2].hasRock))
	{
		timesteps++;
		float random = Rand.rand(1);
		if(random < 0.25 && D.x < 2) //Move right
			D.x++;
		else if(random < 0.5 && D.x > 0) //Move left
			D.x--;
		else if(random < 0.75 && D.y < 2) //Move up
			D.y++;
		else if(random < 1.0 && D.y > 0) //Move down
			D.y--;
		else
			continue;

		if(D.y == 2 && D.hasRock == false) //Curr. position is in the rock row
		{	//AND doesn't already have a rock
			
			switch(D.x)
			{
			case 0: if(rock1 == 1)
					{
						D.hasRock = true;
						rock1 = 0;
					}
					break;
			case 1: if(rock2 == 1)
					{
						D.hasRock = true;
						rock2 = 0;
					}
					break;
			case 2: if(rock3 == 1)
					{
						D.hasRock = true;
						rock3 = 0;
					}
					break;
			}
		}

		else if(D.y == 0 && D.hasRock == true && Pedestals[D.x].hasRock == false) //Curr. position in top row & has a rock
		{
			Pedestals[D.x].hasRock = true;
			D.hasRock = false;
		}
		
	
	}
	return timesteps;
}
double monteCarlo()
{
	double sum = 0.0;
	for(int x = 0; x < MONTE_CARLO_STEPS; x++)
	{
		init();
		sum+=(double)serial();
	}
	sum/=MONTE_CARLO_STEPS;
	return sum;
}

int main()
{
	cout << "Estimated Time over " << MONTE_CARLO_STEPS << " Runs: " << monteCarlo() << endl;
	system("PAUSE");
	return 0;
}